﻿/* This project is to enable the Express edition of Visual Studio
 * have the ability to debug WriteLog external keyboard shortcuts.
 * See the comments in Program.cs regarding how to target this exe to
 * debug your custom WriteLog external keyboard shortcuts.
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace KeyboardShortcutTester
{   // this KeyboardShortcutTester should work as-is EXCEPT
    public partial class MainForm : Form
    {
         WriteLogShortcutHelper.ShortcutHelper sp = // shortcut processor
                // TODO: Change following line to name of your class
                new MyWritelogShortcuts.ShortcutProcessor();
                // Add a reference in this project to your custom assembly.
                // and instance a new one with the same string you also have put in
                // WRITELOG.INI
                // [configuration]
                // ExtShortcutClass=MyWritelogShortcuts.ShortcutProcessor 
        
       // Maintain correspondence between display string and index for a shortcut
        private class ListItem
        {
            private String display;
            private int index;
            public ListItem(String d, int i)
            {
                display = d;
                index = i;
            }
            public override string ToString()
            {
                return display.ToString();
            }
            public int Index { get { return index; } }
        }
      
        WriteLogClrTypes.IWriteL wl;    // WriteLog automation


        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            try
            {
                Object obj =
                    System.Runtime.InteropServices.Marshal.GetActiveObject("WriteLog.Document");
                wl = (WriteLogClrTypes.IWriteL)obj;
            }
            catch (Exception )
            {
                MessageBox.Show("Please Run WriteLog first. Leave it running. Then invoke this tester.");
                Application.Exit();
            }

            List<ListItem> items = new List<ListItem>();
            for (int i = 0; i < sp.ShortcutCount; i++) 
                items.Add(new ListItem(sp[i], i));
            cmdListBox.DataSource = items;
            cmdListBox.SetSelected(0, false);
            cmdListBox.Enabled = true;
        }

        private void cmdListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmdListBox.Enabled)
            {
                ListItem li = (ListItem)cmdListBox.Items[cmdListBox.SelectedIndex];
                if (li != null)
                    sp.InvokeShortcut(li.Index, wl);
            }
        }

    }
}