﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MyWritelogShortcuts
{
    public class ShortcutProcessor : WriteLogShortcutHelper.ShortcutHelper
    {
        /* These are the names of the commands as they will appear
           in WriteLog's Keyboard Shortcuts "Command to run" list: */
        string[] CommandNames = new string[] { 
                "My command 1",  // this is which == 0
                "My command 2"  // this is which == 1
                // ... and you can add as many as you like.

                // They will appear in WriteLog with "External:" prepended.
                // Look in the E's in that menu.
        };

        // you must have this property
        public override int ShortcutCount
        {            get { return CommandNames.Length; }         }

        // and you must have this one
        public override string this[int which]
        {
            get {
                if ((which < 0) || (which >= CommandNames.Length))
                    throw new IndexOutOfRangeException();
                return CommandNames[which];
            }
        }

        // and you must have this method
        public override void InvokeShortcut(int which, WriteLogClrTypes.IWriteL wl)
        {
            if ((which < 0) || (which >= CommandNames.Length))
                throw new IndexOutOfRangeException();

            // you can call methods on the wl object here. You are not limited
            // to the InvokeKeyboardCommand, but it makes a simple demonstration
            // because the result is to simply do exactly what WriteLog would
            // do if you set the CommandToRun to ToolsGraphs or ViewOnlyTheLog.
            switch (which)
            {
                case 0: // "My command 1"
                    wl.InvokeKeyboardCommand("ToolsGraphs");
                    break;

                case 1: // My command 2"
                    wl.InvokeKeyboardCommand("ViewOnlyTheLog");
                   break;
            }
        }
     }
}
